// pages/login/login.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    frameStyle: { useTop: true, name: '比赛信息', leftArrow: true, useBar: false },
    // 主体高度
    infoHeight: '',
    // 数据id
    id: '',
    //详情数据
    info: {},
    //用户信息
    userdata: {},
    //判断用户类别
    type: '',
    //团队id
    blueTeam: {},
    redTeam: {},
    // 现场图片
    match_file: [],
    // 上传比分
    show: false,
    form: {},
  },
  //验证是否输入
  initValidate() {
    const rules = { blue_branch: { required: true }, red_branch: { required: true, }, blue_integral: { required: true }, red_integral: { required: true, } }
    // 验证字段的提示信息，若不传则调用默认的信息
    const messages = { blue_branch: { required: '请输入蓝方比分', }, red_branch: { required: '请输入红方比分', }, blue_integral: { required: '请输入蓝方积分', }, red_integral: { required: '请输入红方积分', } };
    this.WxValidate = new WxValidate(rules, messages)
  },
  back: function () {
    wx.navigateBack({ delta: 0 })
  },
  //上传图片
  imgUpload: async function (e) {
    const that = this;
    let type = that.data.type;
    let redTeam = that.data.redTeam;
    let blueTeam = that.data.blueTeam;
    let user = that.data.userdata;
    let info = that.data.info;
    if (type == '0') {
      wx.showToast({ title: '不可上传', duration: 2000, icon: 'error', })
    } else if (type == '1') {
      if (redTeam || blueTeam) {
        if (redTeam && redTeam.create_id == user._id || blueTeam && blueTeam.create_id == user._id) {
          let data = that.data.match_file;
          let id = that.data.id;
          data.push(e.detail);
          const arr = await app.$post(`/courtAdmin/api/schedule/${id}`, { match_file: data });
          if (arr.errcode === 0) {
            wx.showToast({ title: `上传图片成功`, icon: 'success', duration: 2000 })
            that.watchLogin();
          } else {
            wx.showToast({ title: arr.errmsg, icon: 'success', duration: 2000 })
          }
        } else {
          wx.showToast({ title: '不可上传', duration: 2000, icon: 'error', })
        }
      }
    } else if (type == '2') {
      let redM = info.red_members.find((i) => i.id == user._id);
      let blueM = info.blue_members.find((i) => i.id == user._id);
      if (redM || blueM) {
        let data = that.data.match_file;
        let id = that.data.id;
        data.push(e.detail);
        const arr = await app.$post(`/courtAdmin/api/schedule/${id}`, { match_file: data });
        if (arr.errcode === 0) {
          wx.showToast({ title: `上传图片成功`, icon: 'success', duration: 2000 })
          that.watchLogin();
        } else {
          wx.showToast({ title: arr.errmsg, icon: 'success', duration: 2000 })
        }
      } else {
        wx.showToast({ title: '不可上传', duration: 2000, icon: 'error', })
      }
    }
  },
  //删除图片
  imgDel: async function (e) {
    const that = this;
    let type = that.data.type;
    let redTeam = that.data.redTeam;
    let blueTeam = that.data.blueTeam;
    let user = that.data.userdata;
    let info = that.data.info;
    if (type == '0') {
      wx.showToast({ title: '不可删除', duration: 2000, icon: 'error', })
    } else if (type == '1') {
      if (redTeam || blueTeam) {
        if (redTeam && redTeam.create_id == user._id || blueTeam && blueTeam.create_id == user._id) {
          let id = that.data.id;
          let data = that.data.match_file;
          let arr = data.filter((i, index) => index != e.detail.index)
          const res = await app.$post(`/courtAdmin/api/schedule/${id}`, { match_file: arr });
          if (res.errcode === 0) {
            wx.showToast({ title: `删除图片成功`, icon: 'success', duration: 2000 })
            that.watchLogin();
          } else {
            wx.showToast({ title: arr.errmsg, icon: 'success', duration: 2000 })
          }
        } else {
          wx.showToast({ title: '不可上传', duration: 2000, icon: 'error', })
        }
      }
    } else if (type == '2') {
      wx.showToast({ title: '不可删除', duration: 2000, icon: 'error', })
    }
  },
  // 上传比分
  clickme: async function () {
    const that = this;
    let type = that.data.type;
    let redTeam = that.data.redTeam;
    let blueTeam = that.data.blueTeam;
    let user = that.data.userdata;
    if (type == '0' || type == '2') {
      wx.showToast({ title: `不可上传`, icon: 'error', duration: 2000 })
    } else {
      if (redTeam || blueTeam) {
        if (redTeam && redTeam.create_id == user._id || blueTeam && blueTeam.create_id == user._id) {
          that.setData({ form: that.data.info })
          that.setData({ show: true })
        } else {
          wx.showToast({ title: `不可上传`, icon: 'error', duration: 2000 })
        }
      }
    }
  },
  // 提交比分
  formSubmit: async function (e) {
    const that = this;
    let id = that.data.id;
    let params = e.detail.value;
    if (!this.WxValidate.checkForm(params)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
      return false
    } else {
      const res = await app.$post(`/courtAdmin/api/schedule/${id}`, params);
      if (res.errcode == 0) {
        wx.showToast({ title: '保存成功', duration: 2000, icon: 'success' })
        that.formReset();
        that.watchLogin();
      } else {
        wx.showToast({ title: res.errmsg, icon: 'error', duration: 2000 })
      }
    }
  },
  // 取消提交
  formReset: function () {
    const that = this;
    that.setData({ show: false })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const that = this;
    that.setData({ id: options.id })
    //验证规则函数
    this.initValidate();
    // 计算高度
    this.searchHeight();
    // 监听用户是否登录
    this.watchLogin();
  },
  // 监听用户是否登录
  watchLogin: async function () {
    const that = this;
    let id = that.data.id;
    wx.getStorage({
      key: 'token',
      success: async res => {
        // 用户类别，用户信息
        that.setData({ type: res.data.type, userdata: res.data })
        const arr = await app.$get(`/courtAdmin/api/schedule/${id}`);
        if (arr.errcode === 0) {
          // 比赛信息，红方id，蓝方id
          that.setData({ info: arr.data })
          // 现场图片
          that.setData({ match_file: arr.data.match_file })
          // 查询红方，蓝方信息
          const p1 = await app.$get(`/courtAdmin/api/team/${arr.data.red_id}`);
          const p2 = await app.$get(`/courtAdmin/api/team/${arr.data.blue_id}`);
          if (p1.errcode === 0 && p2.errcode === 0) {
            that.setData({ redTeam: p1.data })
            that.setData({ blueTeam: p2.data })
          }
        }
      },
      fail: res => {
        return wx.redirectTo({ url: '/pages/login/index', })
      }
    })
  },
  // 计算高度
  searchHeight: function () {
    let frameStyle = this.data.frameStyle;
    let client = app.globalData.client;
    // 减去状态栏
    let infoHeight = client.windowHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
    // 是否减去底部菜单
    if (frameStyle.useBar) infoHeight = infoHeight - 50;
    if (infoHeight) this.setData({ infoHeight: infoHeight })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})