// pages/login/login.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    frameStyle: { useTop: false, name: '团队详情', leftArrow: true, useBar: false },
    ids: '',
    src: '/image/adimges.jpg',
    // 主体高度
    infoHeight: '',
    //团队详情
    teamlist: [],
    //参考历史
    historylist: [],
  },
  back: function () {
    wx.navigateBack({ url: '/pages/home/index' })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({ ids: options.id });
    // 计算高度
    this.searchHeight()
    // 监听用户是否登录
    this.watchLogin();
  },
  // 监听用户是否登录
  watchLogin: function () {
    var that = this;
    let id = that.data.ids;
    wx.getStorage({
      key: 'token',
      success: res => {
        //查询数据
        wx.request({
          url: `${app.globalData.publicUrl}/courtAdmin/api/team/${id}`, //接口地址
          method: 'get',
          data: '',
          success(res) {
            that.setData({
              teamlist: res.data.data,
            });
          }
        })
        //查询历史比赛
        this.searchMatch(res.data.data);
      },
      fail: res => {
        return wx.redirectTo({ url: '/pages/login/index', })
      }
    })
  },
  //查询历史比赛
  searchMatch: async function (e) {
    const that = this;
    let id = that.data.ids;
    let data = [];
    const res = await app.$get('/courtAdmin/api/schedule', { red_id: id, status: '2' });
    if (res.errcode === 0) data = res.data;
    const arr = await app.$get('/courtAdmin/api/schedule', { blue_id: id, status: '2' });
    if (arr.errcode === 0) data = [...data, ...arr.data];
    that.setData({ historylist: data })
  },
  // 计算高度
  searchHeight: function () {
    let frameStyle = this.data.frameStyle;
    let client = app.globalData.client;
    let infoHeight = client.windowHeight;
    // 是否去掉状态栏
    if (frameStyle.useTop) infoHeight = infoHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
    // 是否减去底部菜单
    if (frameStyle.useBar) infoHeight = infoHeight - 50;
    if (infoHeight) this.setData({ infoHeight: infoHeight })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})